(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("mapbox-gl-threelayer.js", [], factory);
	else if(typeof exports === 'object')
		exports["mapbox-gl-threelayer.js"] = factory();
	else
		root["mapbox-gl-threelayer.js"] = factory();
})(window, function() {
return (window["webpackJsonpmapbox_gl_threelayer_js"] = window["webpackJsonpmapbox_gl_threelayer_js"] || []).push([[2,3],{

/***/ 66:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(82);


/***/ }),

/***/ 82:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "ThreeLayer", function() { return /* reexport */ src_ThreeLayer; });
__webpack_require__.d(__webpack_exports__, "Threebox", function() { return /* reexport */ src_Threebox; });
__webpack_require__.d(__webpack_exports__, "EventHandler", function() { return /* reexport */ handlers_EventHandler; });
__webpack_require__.d(__webpack_exports__, "ObjectHandler", function() { return /* reexport */ handlers_ObjectHandler; });
__webpack_require__.d(__webpack_exports__, "AnimationHandler", function() { return /* reexport */ handlers_AnimationHandler; });

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/classCallCheck.js
var classCallCheck = __webpack_require__(4);
var classCallCheck_default = /*#__PURE__*/__webpack_require__.n(classCallCheck);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/createClass.js
var createClass = __webpack_require__(5);
var createClass_default = /*#__PURE__*/__webpack_require__.n(createClass);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/defineProperty.js
var defineProperty = __webpack_require__(1);
var defineProperty_default = /*#__PURE__*/__webpack_require__.n(defineProperty);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/regenerator/index.js
var regenerator = __webpack_require__(34);
var regenerator_default = /*#__PURE__*/__webpack_require__.n(regenerator);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/asyncToGenerator.js
var asyncToGenerator = __webpack_require__(56);
var asyncToGenerator_default = /*#__PURE__*/__webpack_require__.n(asyncToGenerator);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/promise.js
var promise = __webpack_require__(35);
var promise_default = /*#__PURE__*/__webpack_require__.n(promise);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/date/now.js
var date_now = __webpack_require__(10);
var now_default = /*#__PURE__*/__webpack_require__.n(date_now);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/instance/for-each.js
var for_each = __webpack_require__(3);
var for_each_default = /*#__PURE__*/__webpack_require__.n(for_each);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/instance/map.js
var instance_map = __webpack_require__(2);
var map_default = /*#__PURE__*/__webpack_require__.n(instance_map);

// EXTERNAL MODULE: ./node_modules/three/build/three.module.js
var three_module = __webpack_require__(0);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/loaders/OBJLoader.js
var OBJLoader = __webpack_require__(57);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/loaders/GLTFLoader.js
var GLTFLoader = __webpack_require__(58);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/loaders/FBXLoader.js + 3 modules
var FBXLoader = __webpack_require__(64);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/loaders/ColladaLoader.js + 1 modules
var ColladaLoader = __webpack_require__(65);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/loaders/MTLLoader.js
var MTLLoader = __webpack_require__(59);

// CONCATENATED MODULE: ./src/Constant.ts
var WORLD_SIZE = 1024000;
var MERCATOR_A = 6378137.0;
var FOV = Math.atan(3 / 4);
var Constant = {
  WORLD_SIZE: WORLD_SIZE,
  PROJECTION_WORLD_SIZE: WORLD_SIZE / (MERCATOR_A * Math.PI * 2),
  MERCATOR_A: MERCATOR_A,
  // 900913 projection property
  DEG2RAD: Math.PI / 180,
  RAD2DEG: 180 / Math.PI,
  EARTH_CIRCUMFERENCE: 40075000,
  // In meters
  FOV: FOV,
  // Math.atan(3/4) radians. If this value is changed, FOV_DEGREES must be calculated
  FOV_DEGREES: FOV * 360 / (Math.PI * 2),
  // Math.atan(3/4) in degrees
  TILE_SIZE: 512
};
/* harmony default export */ var src_Constant = (Constant);
// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/instance/some.js
var some = __webpack_require__(60);
var some_default = /*#__PURE__*/__webpack_require__.n(some);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/object/keys.js
var keys = __webpack_require__(23);
var keys_default = /*#__PURE__*/__webpack_require__.n(keys);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/instance/splice.js
var splice = __webpack_require__(22);
var splice_default = /*#__PURE__*/__webpack_require__.n(splice);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/toConsumableArray.js
var toConsumableArray = __webpack_require__(61);
var toConsumableArray_default = /*#__PURE__*/__webpack_require__.n(toConsumableArray);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/helpers/typeof.js
var helpers_typeof = __webpack_require__(12);
var typeof_default = /*#__PURE__*/__webpack_require__.n(helpers_typeof);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/array/is-array.js
var is_array = __webpack_require__(19);
var is_array_default = /*#__PURE__*/__webpack_require__.n(is_array);

// CONCATENATED MODULE: ./src/Validator.ts


var Validator_Validator = function Validator() {
  classCallCheck_default()(this, Validator);
};

/* harmony default export */ var src_Validator = (Validator_Validator);
// CONCATENATED MODULE: ./src/Utils.ts















var Utils_Utils = /*#__PURE__*/function () {
  function Utils() {
    classCallCheck_default()(this, Utils);

    defineProperty_default()(this, "Validator", new src_Validator());

    defineProperty_default()(this, "exposedMethods", ['projectToWorld', 'projectedUnitsPerMeter', 'extend', 'unprojectFromWorld']);
  }

  createClass_default()(Utils, [{
    key: "prettyPrintMatrix",

    /**
     *
     *
     * @author salgum1114
     * @param {number[]} uglymatrix
     */
    value: function prettyPrintMatrix(uglymatrix) {
      for (var s = 0; s < 4; s++) {
        var quartet = [uglymatrix[s], uglymatrix[s + 4], uglymatrix[s + 8], uglymatrix[s + 12]];
        console.log(map_default()(quartet).call(quartet, function (num) {
          return num.toFixed(4);
        }));
      }
    }
    /**
     *
     *
     * @author salgum1114
     * @param {number} fovy
     * @param {number} aspect
     * @param {number} near
     * @param {number} far
     * @returns
     */

  }, {
    key: "makePerspectiveMatrix",
    value: function makePerspectiveMatrix(fovy, aspect, near, far) {
      var out = new three_module["Matrix4"]();
      var f = 1.0 / Math.tan(fovy / 2);
      var nf = 1 / (near - far);
      var newMatrix = [f / aspect, 0, 0, 0, 0, f, 0, 0, 0, 0, (far + near) * nf, -1, 0, 0, 2 * far * near * nf, 0];
      out.elements = newMatrix;
      return out;
    }
    /**
     * gimme radians
     *
     * @author salgum1114
     * @param {(number | [number, number, number] | { x: number; y: number; z: number })} deg
     * @returns
     */

  }, {
    key: "radify",
    value: function radify(deg) {
      var convert = function convert(degrees) {
        degrees = degrees || 0;
        return Math.PI * 2 * degrees / 360;
      };

      if (is_array_default()(deg)) {
        // if [x,y,z] array of rotations
        return map_default()(deg).call(deg, function (degree) {
          return convert(degree);
        });
      } else if (typeof_default()(deg) === 'object') {
        // if {x, y, z} rotation object
        return [convert(deg.x), convert(deg.y), convert(deg.z)];
      } else {
        // if just a number
        return convert(deg);
      }
    }
    /**
     * gimme degrees
     *
     * @author salgum1114
     * @param {(number | { x: number; y: number; z: number })} rad
     * @returns
     */

  }, {
    key: "degreeify",
    value: function degreeify(rad) {
      var convert = function convert(radians) {
        radians = radians || 0;
        return radians * 360 / (Math.PI * 2);
      };

      if (typeof_default()(rad) === 'object') {
        return [convert(rad.x), convert(rad.y), convert(rad.z)];
      } else {
        return convert(rad);
      }
    }
    /**
     *
     *
     * @author salgum1114
     * @param {[number, number, number]} coords
     * @returns
     */

  }, {
    key: "projectToWorld",
    value: function projectToWorld(coords) {
      // Spherical mercator forward projection, re-scaling to WORLD_SIZE
      var projected = [-src_Constant.MERCATOR_A * src_Constant.DEG2RAD * coords[0] * src_Constant.PROJECTION_WORLD_SIZE, -src_Constant.MERCATOR_A * Math.log(Math.tan(Math.PI * 0.25 + 0.5 * src_Constant.DEG2RAD * coords[1])) * src_Constant.PROJECTION_WORLD_SIZE]; // z dimension, defaulting to 0 if not provided

      if (!coords[2]) {
        projected.push(0);
      } else {
        var pixelsPerMeter = this.projectedUnitsPerMeter(coords[1]);
        projected.push(coords[2] * pixelsPerMeter);
      }

      var result = new three_module["Vector3"](projected[0], projected[1], projected[2]);
      return result;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {number} latitude
     * @returns
     */

  }, {
    key: "projectedUnitsPerMeter",
    value: function projectedUnitsPerMeter(latitude) {
      return Math.abs(src_Constant.WORLD_SIZE / Math.cos(src_Constant.DEG2RAD * latitude) / src_Constant.EARTH_CIRCUMFERENCE);
    }
    /**
     *
     *
     * @author salgum1114
     * @param {[number, number, number]} centerLatLng
     * @param {Vector3[]} vertices
     * @returns
     */

  }, {
    key: "scaleVerticesToMeters",
    value: function scaleVerticesToMeters(centerLatLng, vertices) {
      var pixelsPerMeter = this.projectedUnitsPerMeter(centerLatLng[1]); // const centerProjected = this.projectToWorld(centerLatLng);

      for_each_default()(vertices).call(vertices, function (vertice) {
        return vertice.multiplyScalar(pixelsPerMeter);
      });

      return vertices;
    }
    /**
     * @deprecated
     *
     * @author salgum1114
     * @param {[number, number, number]} coords
     */

  }, {
    key: "projectToScreen",
    value: function projectToScreen(coords) {
      console.log('[WARNING] Projecting to screen coordinates is not yet implemented', coords);
    }
    /**
     * @deprecated
     *
     * @author salgum1114
     * @param {[number, number, number]} pixel
     */

  }, {
    key: "unprojectFromScreen",
    value: function unprojectFromScreen(pixel) {
      console.log('[WARNING] unproject is not yet implemented', pixel);
    }
    /**
     * world units to lnglat
     *
     * @author salgum1114
     * @param {{ x: number; y: number; z: number }} worldUnits
     * @returns
     */

  }, {
    key: "unprojectFromWorld",
    value: function unprojectFromWorld(worldUnits) {
      var unprojected = [-worldUnits.x / (src_Constant.MERCATOR_A * src_Constant.DEG2RAD * src_Constant.PROJECTION_WORLD_SIZE), 2 * (Math.atan(Math.exp(worldUnits.y / (src_Constant.PROJECTION_WORLD_SIZE * -src_Constant.MERCATOR_A))) - Math.PI / 4) / src_Constant.DEG2RAD];
      var pixelsPerMeter = this.projectedUnitsPerMeter(unprojected[1]); // z dimension

      var height = worldUnits.z || 0;
      unprojected.push(height / pixelsPerMeter);
      return unprojected;
    }
    /**
     * @deprecated
     *
     * @author salgum1114
     * @param {Object3D} obj
     * @param {PerspectiveCamera} camera
     * @returns
     */

  }, {
    key: "toScreenPosition",
    value: function toScreenPosition(obj, camera) {
      console.warn('[DEPRECATED] Not used', obj, camera); // const vector = new THREE.Vector3();
      // const widthHalf = 0.5 * renderer.context.canvas.width;
      // const heightHalf = 0.5 * renderer.context.canvas.height;
      // obj.updateMatrixWorld();
      // vector.setFromMatrixPosition(obj.matrixWorld);
      // vector.project(camera);
      // vector.x = (vector.x * widthHalf) + widthHalf;
      // vector.y = - (vector.y * heightHalf) + heightHalf;
      // return {
      // 	x: vector.x,
      // 	y: vector.y
      // };
    }
    /**
     * get the center point of a feature
     *
     * @author salgum1114
     * @param {GeoJSON.Feature<any>} feature
     * @param {ThreeboxObject} [obj]
     * @param {number} [level]
     * @returns
     */

  }, {
    key: "getFeatureCenter",
    value: function getFeatureCenter(feature, obj, level) {
      var _coordinates;

      var center = [];
      var latitude = 0;
      var longitude = 0;
      var height = 0;
      var coordinates = []; // deep clone to avoid modifying the original array

      (_coordinates = coordinates).push.apply(_coordinates, toConsumableArray_default()(feature.geometry.coordinates[0]));

      if (feature.geometry.type === 'Point') {
        center = coordinates[0];
      } else {
        // features in mapbox repeat the first coordinates at the end. We remove it.
        if (feature.geometry.type === 'MultiPolygon') coordinates = coordinates[0];

        splice_default()(coordinates).call(coordinates, -1, 1);

        for_each_default()(coordinates).call(coordinates, function (c) {
          latitude += c[0];
          longitude += c[1];
        });

        center = [latitude / coordinates.length, longitude / coordinates.length];
      }

      height = this.getObjectHeightOnFloor(feature, obj, level);
      center.length < 3 ? center.push(height) : center[2] = height;
      return center;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {GeoJSON.Feature<any>} feature
     * @param {ThreeboxObject} obj
     * @param {number} [level=feature.properties.level || 0]
     * @returns
     */

  }, {
    key: "getObjectHeightOnFloor",
    value: function getObjectHeightOnFloor(feature, obj) {
      var level = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : feature.properties.level || 0;
      var floorHeightMin = level * (feature.properties.levelHeight || 0); // object height is modelSize.z + base_height or min_height configured for this object

      var base = feature.properties.base_height || feature.properties.min_height || 0; // let height = ((obj && obj.model) ? obj.modelSize.z : (feature.properties.height - base));

      var height = obj && obj.model ? 0 : feature.properties.height - base;
      var objectHeight = height + base;
      var modelHeightFloor = floorHeightMin + objectHeight;
      return modelHeightFloor;
    }
    /**
     * @deprecated
     *
     * @author salgum1114
     * @param {*} obj
     */

  }, {
    key: "flipMaterialSides",
    value: function flipMaterialSides(obj) {
      console.warn('[DEPRECATED] Not used', obj);
    }
    /**
     * to improve precision, normalize a series of vector3's to their collective center, and move the resultant mesh to that center
     *
     * @author salgum1114
     * @param {Vector3[]} vertices
     * @returns
     */

  }, {
    key: "normalizeVertices",
    value: function normalizeVertices(vertices) {
      var geometry = new three_module["Geometry"]();

      for_each_default()(vertices).call(vertices, function (v3) {
        return geometry.vertices.push(v3);
      });

      geometry.computeBoundingSphere();
      var center = geometry.boundingSphere.center; // const radius = geometry.boundingSphere.radius;

      var scaled = map_default()(vertices).call(vertices, function (v3) {
        var normalized = v3.sub(center);
        return normalized;
      });

      return {
        vertices: scaled,
        position: center
      };
    }
    /**
     * flatten an array of Vector3's into a shallow array of values in x-y-z order, for bufferGeometry
     *
     * @author salgum1114
     * @param {Vector3[]} vectors
     * @returns
     */

  }, {
    key: "flattenVectors",
    value: function flattenVectors(vectors) {
      var flattenedArray = [];

      for_each_default()(vectors).call(vectors, function (vertex) {
        return flattenedArray.push(vertex.x, vertex.y, vertex.z);
      });

      return flattenedArray;
    } // convert a line/polygon to Vector3's

  }, {
    key: "lnglatsToWorld",
    value: function lnglatsToWorld(coords) {
      var _this = this;

      var vector3 = map_default()(coords).call(coords, function (pt) {
        var p = _this.projectToWorld(pt);

        var v3 = new three_module["Vector3"](p.x, p.y, p.z);
        return v3;
      });

      return vector3;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {Record<string, any>} original
     * @param {Record<string, any>} addition
     */

  }, {
    key: "extend",
    value: function extend(original, addition) {
      var _context;

      for_each_default()(_context = keys_default()(addition)).call(_context, function (key) {
        return original[key] = addition[key];
      });
    }
    /**
     *
     *
     * @author salgum1114
     * @param {Record<string, any>} original
     * @returns
     */

  }, {
    key: "clone",
    value: function clone(original) {
      var _context2;

      var clone = {};

      for_each_default()(_context2 = keys_default()(original)).call(_context2, function (key) {
        return clone[key] = original[key];
      });

      return clone;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {number} n
     * @param {number} min
     * @param {number} max
     * @returns
     */

  }, {
    key: "clamp",
    value: function clamp(n, min, max) {
      return Math.min(max, Math.max(min, n));
    }
    /**
     * retrieve object parameters from an options object
     *
     * @author salgum1114
     * @param {(number | { x: number; y: number; z: number })} rotation
     * @param {[number, number, number]} currentRotation
     * @returns
     */

  }, {
    key: "rotation",
    value: function rotation(_rotation, currentRotation) {
      // [jscastro] rotation default 0
      var r = _rotation;

      if (!r) {
        r = 0;
      } // if number provided, rotate only in Z by that amount


      if (typeof r === 'number') {
        r = {
          z: r
        };
      }

      var degrees = this.applyDefault([r.x, r.y, r.z], currentRotation);
      var radians = this.radify(degrees);
      return radians;
    }
    /**
     * retrieve object parameters from an options object
     *
     * @author salgum1114
     * @param {(number | { x: number; y: number; z: number })} scale
     * @param {[number, number, number]} currentScale
     * @returns
     */

  }, {
    key: "scale",
    value: function scale(_scale, currentScale) {
      // [jscastro] scale default 1
      var s = _scale;

      if (!s) {
        s = 1;
      }

      if (typeof s === 'number') {
        return [s, s, s];
      } else {
        return this.applyDefault([s.x, s.y, s.z], currentScale);
      }
    }
    /**
     * retrieve object parameters from an options object
     *
     * @author salgum1114
     * @param {[number, number, number]} array
     * @param {[number, number, number]} current
     * @returns
     */

  }, {
    key: "applyDefault",
    value: function applyDefault(array, current) {
      return map_default()(array).call(array, function (item, index) {
        item = item || current[index];
        return item;
      });
    }
    /**
     *
     *
     * @author salgum1114
     * @param {Record<string, any>} userInputs
     * @param {Record<string, any>} defaults
     * @returns
     */

  }, {
    key: "validate",
    value: function validate(userInputs, defaults) {
      var _context3;

      var _userInputs = userInputs || {};

      var validatedOutput = {};
      this.extend(validatedOutput, userInputs);

      some_default()(_context3 = keys_default()(defaults)).call(_context3, function (key) {
        if (_userInputs[key] === undefined) {
          // make sure required params are present
          if (defaults[key] === null) {
            console.error(key + ' is required');
            return false;
          } else {
            validatedOutput[key] = defaults[key];
          }
        } else {
          validatedOutput[key] = _userInputs[key];
        }

        return false;
      });

      return validatedOutput;
    }
  }]);

  return Utils;
}();

/* harmony default export */ var src_Utils = (new Utils_Utils());
// CONCATENATED MODULE: ./src/CameraSync.ts








var CameraSync_CameraSync = /*#__PURE__*/function () {
  function CameraSync(map, camera, world) {
    var _this = this;

    classCallCheck_default()(this, CameraSync);

    defineProperty_default()(this, "map", void 0);

    defineProperty_default()(this, "camera", void 0);

    defineProperty_default()(this, "world", void 0);

    defineProperty_default()(this, "active", void 0);

    defineProperty_default()(this, "state", void 0);

    defineProperty_default()(this, "cameraTranslateZ", void 0);

    this.map = map;
    this.camera = camera;
    this.active = true;
    this.camera.matrixAutoUpdate = false; // We're in charge of the camera now!
    // Postion and configure the world group so we can scale it appropriately when the camera zooms

    this.world = world || new three_module["Group"]();
    this.world.position.x = this.world.position.y = src_Constant.WORLD_SIZE / 2;
    this.world.matrixAutoUpdate = false; // set up basic camera state

    this.state = {
      fov: src_Constant.FOV,
      translateCenter: new three_module["Matrix4"]().makeTranslation(src_Constant.WORLD_SIZE / 2, -src_Constant.WORLD_SIZE / 2, 0),
      worldSizeRatio: src_Constant.TILE_SIZE / src_Constant.WORLD_SIZE
    };

    map_default()(this).on('move', function () {
      _this.updateCamera();
    }).on('resize', function () {
      _this.setupCamera();
    });

    this.setupCamera();
  }
  /**
   * Set up the camera
   *
   * @author salgum1114
   */


  createClass_default()(CameraSync, [{
    key: "setupCamera",
    value: function setupCamera() {
      var map = map_default()(this);

      var transform = map.transform;
      this.camera.aspect = transform.width / transform.height; // bug fixed, if aspect is not reset raycast will fail on map resize

      this.camera.updateProjectionMatrix();
      var halfFov = this.state.fov / 2;
      var offset = {
        x: transform.width / 2,
        y: transform.height / 2
      }; // transform.centerOffset;

      var cameraToCenterDistance = 0.5 / Math.tan(halfFov) * transform.height;
      var maxPitch = transform._maxPitch * Math.PI / 180;
      var acuteAngle = Math.PI / 2 - maxPitch;
      this.state.cameraToCenterDistance = cameraToCenterDistance;
      this.state.offset = offset;
      this.state.cameraTranslateZ = new three_module["Matrix4"]().makeTranslation(0, 0, cameraToCenterDistance);
      this.state.maxFurthestDistance = cameraToCenterDistance * 0.95 * (Math.cos(acuteAngle) * Math.sin(halfFov) / Math.sin(Math.max(0.01, Math.min(Math.PI - 0.01, acuteAngle - halfFov))) + 1);
      this.updateCamera();
    }
  }, {
    key: "updateCamera",
    value: function updateCamera() {
      if (!this.camera) {
        console.warn('Not initialized Camera object');
        return;
      }

      var map = map_default()(this);

      var transform = map.transform; // Furthest distance optimized by @satorbs
      // https://github.com/satorbs/threebox/blob/master/src/Camera/CameraSync.js

      var groundAngle = Math.PI / 2 + transform._pitch;
      var fovAboveCenter = this.state.fov * (0.5 + this.state.offset.y / transform.height);
      var topHalfSurfaceDistance = Math.sin(fovAboveCenter) * this.state.cameraToCenterDistance / Math.sin(src_Utils.clamp(Math.PI - groundAngle - fovAboveCenter, 0.01, Math.PI - 0.01)); // Calculate z distance of the farthest fragment that should be rendered.

      var furthestDistance = Math.cos(Math.PI / 2 - transform._pitch) * topHalfSurfaceDistance + this.state.cameraToCenterDistance; // Add a bit extra to avoid precision problems when a fragment's distance is exactly `furthestDistance`

      var farZ = Math.min(furthestDistance * 1.01, this.state.maxFurthestDistance); // someday @ansis set further near plane to fix precision for deckgl,so we should fix it to use mapbox-gl v1.3+ correctly
      // https://github.com/mapbox/mapbox-gl-js/commit/5cf6e5f523611bea61dae155db19a7cb19eb825c#diff-5dddfe9d7b5b4413ee54284bc1f7966d

      var nearZ = transform.height / 50;
      this.camera.projectionMatrix = src_Utils.makePerspectiveMatrix(this.state.fov, transform.width / transform.height, nearZ, farZ); // Unlike the Mapbox GL JS camera, separate camera translation and rotation out into its world matrix
      // If this is applied directly to the projection matrix, it will work OK but break raycasting

      var cameraWorldMatrix = this.calcCameraMatrix(transform._pitch, transform.angle);
      this.camera.matrixWorld.copy(cameraWorldMatrix);
      var zoomPow = transform.scale * this.state.worldSizeRatio; // Handle scaling and translation of objects in the map in the world's matrix transform, not the camera

      var scale = new three_module["Matrix4"]();
      var translateMap = new three_module["Matrix4"]();
      var rotateMap = new three_module["Matrix4"]();
      scale.makeScale(zoomPow, zoomPow, zoomPow);
      var x = transform.x || transform.point.x;
      var y = transform.y || transform.point.y;
      translateMap.makeTranslation(-x, y, 0);
      rotateMap.makeRotationZ(Math.PI);
      this.world.matrix = new three_module["Matrix4"]().premultiply(rotateMap).premultiply(this.state.translateCenter).premultiply(scale).premultiply(translateMap); // utils.prettyPrintMatrix(this.camera.projectionMatrix.elements);
    }
    /**
     * Calculate Camera Matrix
     *
     * @author salgum1114
     * @param {number} [pitch]
     * @param {number} [angle]
     * @param {Matrix4} [translateZ]
     * @returns
     */

  }, {
    key: "calcCameraMatrix",
    value: function calcCameraMatrix(pitch, angle, translateZ) {
      var map = map_default()(this);

      var transform = map.transform;

      var _pitch = pitch === undefined ? transform._pitch : pitch;

      var _angle = angle === undefined ? transform.angle : angle;

      var _translateZ = translateZ === undefined ? this.state.cameraTranslateZ : translateZ;

      return new three_module["Matrix4"]().premultiply(_translateZ).premultiply(new three_module["Matrix4"]().makeRotationX(_pitch)).premultiply(new three_module["Matrix4"]().makeRotationZ(_angle));
    }
  }]);

  return CameraSync;
}();

/* harmony default export */ var src_CameraSync = (CameraSync_CameraSync);
// CONCATENATED MODULE: ./src/Material.ts


var MaterialDefaultOption = {
  material: 'MeshBasicMaterial',
  color: 'black',
  opacity: 1
};

var Material_Material = function Material(option) {
  var output;

  var _option;

  if (option) {
    _option = src_Utils.validate(option, MaterialDefaultOption);

    if (_option.material && _option.material.isMaterial) {
      // check if user provided material object
      output = _option.material;
    } else if (_option.material || _option.color || _option.opacity) {
      // check if user provided any material parameters. create new material object based on that.
      var three = three_module;
      output = new three[_option.material]({
        color: _option.color,
        transparent: _option.opacity < 1
      });
    } else {
      // if neither, return default material
      output = generateDefaultMaterial();
    }

    output.opacity = _option.opacity;
  } else {
    // if no options, return default
    output = generateDefaultMaterial();
  }

  function generateDefaultMaterial() {
    var three = three_module;
    return three[MaterialDefaultOption.material]({
      color: MaterialDefaultOption.color
    });
  }

  return output;
};

/* harmony default export */ var src_Material = (Material_Material);
// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/object/define-property.js
var define_property = __webpack_require__(6);
var define_property_default = /*#__PURE__*/__webpack_require__.n(define_property);

// EXTERNAL MODULE: ./node_modules/@babel/runtime-corejs3/core-js-stable/instance/slice.js
var slice = __webpack_require__(62);
var slice_default = /*#__PURE__*/__webpack_require__.n(slice);

// EXTERNAL MODULE: ./node_modules/three/examples/jsm/renderers/CSS2DRenderer.js
var CSS2DRenderer = __webpack_require__(36);

// CONCATENATED MODULE: ./src/handlers/ObjectHandler.ts











var ObjectHandler_ObjectHandler = /*#__PURE__*/function () {
  function ObjectHandler(threebox, map) {
    classCallCheck_default()(this, ObjectHandler);

    defineProperty_default()(this, "threebox", void 0);

    defineProperty_default()(this, "map", void 0);

    defineProperty_default()(this, "defaults", {
      colors: {
        red: new three_module["Color"](0xff0000),
        yellow: new three_module["Color"](0xffff00),
        green: new three_module["Color"](0x00ff00),
        black: new three_module["Color"](0x000000)
      },
      materials: {
        boxNormalMaterial: new three_module["LineBasicMaterial"]({
          color: new three_module["Color"](0xff0000)
        }),
        boxOverMaterial: new three_module["LineBasicMaterial"]({
          color: new three_module["Color"](0xffff00)
        }),
        boxSelectedMaterial: new three_module["LineBasicMaterial"]({
          color: new three_module["Color"](0x00ff00)
        })
      },
      line: {
        geometry: null,
        color: 'black',
        width: 1,
        opacity: 1
      },
      sphere: {
        position: [0, 0, 0],
        radius: 1,
        sides: 20,
        units: 'scene',
        material: 'MeshBasicMaterial',
        adjustment: {
          x: 0,
          y: 0,
          z: 0
        }
      },
      label: {
        htmlElement: null,
        cssClass: ' label3D',
        alwaysVisible: false,
        topMargin: -0.5,
        feature: null
      },
      tooltip: {
        text: '',
        cssClass: 'toolTip text-xs',
        mapboxStyle: false,
        topMargin: 0,
        feature: null
      },
      tube: {
        geometry: null,
        radius: 1,
        sides: 6,
        material: 'MeshBasicMaterial'
      },
      extrusion: {
        footprint: null,
        base: 0,
        top: 100,
        color: 'black',
        material: 'MeshBasicMaterial',
        scaleToLatitude: false
      },
      loadModel: {
        type: null,
        obj: null,
        units: 'scene',
        scale: 1,
        rotation: 0,
        defaultAnimation: 0,
        adjustment: {
          x: 0,
          y: 0,
          z: 0
        }
      },
      object3D: {
        obj: null,
        units: 'scene',
        adjustment: {
          x: 0,
          y: 0,
          z: 0
        }
      }
    });

    defineProperty_default()(this, "geometries", {
      line: ['LineString'],
      tube: ['LineString'],
      sphere: ['Point']
    });

    this.threebox = threebox;
    this.map = map;
  } // standard 1px line with gl


  createClass_default()(ObjectHandler, [{
    key: "line",
    value: function line(obj) {
      obj = this.threebox.utils.validate(obj, this.defaults.line); // project to world and normalize

      var straightProject = this.threebox.utils.lnglatsToWorld(obj.geometry);
      var normalized = this.threebox.utils.normalizeVertices(straightProject); // flatten array for buffergeometry

      var flattenedArray = this.threebox.utils.flattenVectors(normalized.vertices);
      var positions = new Float32Array(flattenedArray); // 3 vertices per point

      var geometry = new three_module["BufferGeometry"]();
      geometry.setAttribute('position', new three_module["BufferAttribute"](positions, 3)); // material

      var material = new three_module["LineBasicMaterial"]({
        color: 0xff0000,
        linewidth: 21
      });
      var line = new three_module["Line"](geometry, material); // line.options = options || {};

      line.position.copy(normalized.position);
      return line;
    }
    /**
     * @deprecated
     *
     * @author salgum1114
     * @param {*} option
     */

  }, {
    key: "extrusion",
    value: function extrusion(option) {
      console.warn('[DEPRECATED] Not used', option);
    }
  }, {
    key: "addMethods",
    value: function addMethods(obj, isStatic) {
      var _this = this;

      var _self = this;

      if (isStatic) {} else {
        // [jscastro] Auxiliar method to rotate an object on an axis
        var applyAxisAngle = function applyAxisAngle(model, point, axis, degrees) {
          var theta = _self.threebox.utils.radify(degrees);

          model.position.sub(point); // remove the offset

          model.position.applyAxisAngle(axis, theta); // rotate the POSITION

          model.position.add(point); // re-add the offset

          model.rotateOnAxis(axis, theta);
          map_default()(_self).repaint = true;
        };

        if (!obj.coordinates) {
          obj.coordinates = [0, 0, 0];
        } // Bestow this mesh with animation superpowers and keeps track of its movements in the global animation queue


        _self.threebox.animations.enroll(obj);

        obj.setCoords = function (lnglat) {
          /**
           * Place the given object on the map, centered around the provided longitude and latitude
           * The object's internal coordinates are assumed to be in meter-offset format, meaning
           * 1 unit represents 1 meter distance away from the provided coordinate.
           */
          // If object already added, scale the model so that its units are interpreted as meters at the given latitude
          // [jscastro] this method could be needed more times
          if (obj.userData.units === 'meters') {
            var s = _this.threebox.utils.projectedUnitsPerMeter(lnglat[1]);

            if (!s) {
              s = 1;
            }

            s = Number(s.toFixed(7)); // this precision level is to avoid deviations on the size of the same object

            if (typeof s === 'number') {
              obj.scale.set(s, s, s);
            } else {
              var _s = s;
              obj.scale.set(_s.x, _s.y, _s.z);
            } // initialize the object size and it will rescale the rest

          } // CSS2DObjects could bring an specific vertical positioning to correct in units


          if (obj.userData.topMargin && obj.userData.feature) {
            lnglat[2] += (obj.userData.feature.properties.height - (obj.userData.feature.properties.base_height || obj.userData.feature.properties.min_height || 0)) * obj.userData.topMargin;
          }

          obj.coordinates = lnglat;
          obj.set({
            position: lnglat
          }); // Each time the object is positioned, set modelHeight property and project the floor

          obj.modelHeight = obj.coordinates[2];
          obj.setBoundingBoxShadowFloor();
          return obj;
        };

        obj.setTranslate = function (lnglat) {
          obj.set({
            translate: lnglat
          });
          return obj;
        };

        obj.setRotation = function (xyz) {
          if (typeof xyz === 'number') {
            xyz = {
              z: xyz
            };
          }

          var r = {
            x: _this.threebox.utils.radify(xyz.x) || obj.rotation.x,
            y: _this.threebox.utils.radify(xyz.y) || obj.rotation.y,
            z: _this.threebox.utils.radify(xyz.z) || obj.rotation.z
          };
          obj.setObject({
            rotation: [r.x, r.y, r.z]
          });
        }; // [jscastro] added method to adjust 3D models to their issues with center position for rotation


        obj.calcAdjustedPosition = function (lnglat, xyz, inverse) {
          var location = slice_default()(lnglat).call(lnglat); // we convert the units to Long/Lat/Height


          var newCoords = _this.threebox.utils.unprojectFromWorld(obj.modelSize);

          if (inverse) {
            // each model will have different adjustment attributes, we add them for x, y, z
            location[0] -= xyz.x !== 0 ? newCoords[0] / xyz.x : 0;
            location[1] -= xyz.y !== 0 ? newCoords[1] / xyz.y : 0;
            location[2] -= xyz.z !== 0 ? newCoords[2] / xyz.z : 0;
          } else {
            // each model will have different adjustment attributes, we add them for x, y, z
            location[0] += xyz.x !== 0 ? newCoords[0] / xyz.x : 0;
            location[1] += xyz.y !== 0 ? newCoords[1] / xyz.y : 0;
            location[2] += xyz.z !== 0 ? newCoords[2] / xyz.z : 0;
          }

          return location;
        }; // [jscastro] added method to rotate on objects on an axis instead of centers


        obj.setRotationAxis = function (xyz) {
          if (typeof xyz === 'number') {
            xyz = {
              z: xyz
            };
          }

          var bb = obj.modelBox();
          var point = new three_module["Vector3"](bb.max.x, bb.max.y, bb.min.z); // apply Axis rotation on angle

          if (xyz.x !== 0) {
            applyAxisAngle(obj, point, new three_module["Vector3"](0, 0, 1), xyz.x);
          }

          if (xyz.y !== 0) {
            applyAxisAngle(obj, point, new three_module["Vector3"](0, 0, 1), xyz.y);
          }

          if (xyz.z !== 0) {
            applyAxisAngle(obj, point, new three_module["Vector3"](0, 0, 1), xyz.z);
          }
        };

        var _boundingBox; // [jscastro] added property for boundingBox helper


        define_property_default()(obj, 'boundingBox', {
          get: function get() {
            return _boundingBox;
          },
          set: function set(value) {
            _boundingBox = value;
          }
        });

        var _boundingBoxShadow; // [jscastro] added property for boundingBox helper


        define_property_default()(obj, 'boundingBoxShadow', {
          get: function get() {
            return _boundingBoxShadow;
          },
          set: function set(value) {
            _boundingBoxShadow = value;
          }
        }); // [jscastro] added method to create a bounding box and a shadow box


        obj.drawBoundingBox = function () {
          // let's create 2 wireframes, one for the object and one to project on the floor position
          var bb = obj.box3(); // create the group to return

          var boxGrid = new three_module["Group"]();
          boxGrid.name = 'BoxGrid';
          boxGrid.updateMatrixWorld(true);
          var boxModel = new three_module["Box3Helper"](bb, _self.defaults.colors.yellow);
          boxModel.name = 'BoxModel';
          boxGrid.add(boxModel);
          boxModel.layers.disable(0); // it makes the object invisible for the raycaster

          obj.boundingBox = boxModel; // it needs to clone, to avoid changing the object by reference

          var bb2 = bb.clone(); // we make the second box flat and at the floor height level

          bb2.max.z = bb2.min.z;
          var boxShadow = new three_module["Box3Helper"](bb2, _self.defaults.colors.black);
          boxShadow.name = 'BoxShadow';
          boxGrid.add(boxShadow);
          boxShadow.layers.disable(0); // it makes the object invisible for the raycaster

          obj.boundingBoxShadow = boxShadow;
          boxGrid.visible = false; // visibility is managed from the parent

          return boxGrid;
        }; // [jscastro] added method to position the shadow box on the floor depending the object height


        obj.setBoundingBoxShadowFloor = function () {
          if (obj.boundingBox) {
            obj.boundingBoxShadow.box.max.z = -obj.modelHeight;
            obj.boundingBoxShadow.box.min.z = -obj.modelHeight;
          }
        };

        var _label; // [jscastro] added property for wireframes state


        define_property_default()(obj, 'label', {
          get: function get() {
            return _label;
          },
          set: function set(value) {
            _label = value;
          }
        });

        var _tooltip; // [jscastro] added property for simulated tooltip


        define_property_default()(obj, 'tooltip', {
          get: function get() {
            return _tooltip;
          },
          set: function set(value) {
            _tooltip = value;
          }
        }); // [jscastro] added property to redefine visible, including the label and tooltip


        define_property_default()(obj, 'visibility', {
          get: function get() {
            return obj.visible;
          },
          set: function set(value) {
            var _value = value;

            if (value === 'visible' || value === true) {
              _value = true;
              if (obj.label) obj.label.visible = _value;
            } else if (value === 'none' || value === false) {
              _value = false;
              if (obj.label && obj.label.alwaysVisible) obj.label.visible = _value;
              if (obj.tooltip) obj.tooltip.visible = _value;
            } else return;

            if (obj.visible !== _value) {
              obj.visible = _value;

              if (obj.model) {
                obj.model.traverse(function (c) {
                  if (c.type === 'Mesh' || c.type === 'SkinnedMesh') {
                    if (_value) {
                      c.layers.enable(0); // this makes the meshes visible for raycast
                    } else {
                      c.layers.disable(0); // this makes the meshes invisible for raycast
                    }
                  }

                  if (c.type === 'LineSegments') {
                    c.layers.disableAll();
                  }
                });
              }
            }
          }
        }); // [jscastro] add CSS2 label method


        obj.addLabel = function (element) {
          var visible = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

          if (element) {
            // we add it to the first children to get same boxing and position
            // obj.children[0].add(obj.drawLabel(text, height));
            obj.children[0].add(obj.drawLabelHTML(element, visible));
          }
        }; // [jscastro] draw label method can be invoked separately


        obj.drawLabelHTML = function (element) {
          var visible = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

          var div = _self.drawLabelHTML(element, _self.defaults.label.cssClass);

          var size = obj.getSize();
          obj.label = new CSS2DRenderer["a" /* CSS2DObject */](div);
          obj.label.position.set(-size.x / 2, -size.y / 2, -size.z / 2);
          obj.label.visible = visible;
          obj.label.alwaysVisible = visible;
          return obj.label;
        }; // [jscastro] add tooltip method


        obj.addTooltip = function (tooltipText) {
          var mapboxStyle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
          var center = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
            x: 0,
            y: 0,
            z: 0
          };

          if (tooltipText) {
            var divToolTip = _self.drawTooltip(tooltipText, mapboxStyle);

            var size = obj.getSize();

            if (obj.tooltip) {
              obj.tooltip.remove();
              obj.tooltip = null;
            }

            obj.tooltip = new CSS2DRenderer["a" /* CSS2DObject */](divToolTip);
            obj.tooltip.position.set(size.x * center.x, size.y * center.y, size.z); // top-centered

            obj.tooltip.visible = false; // only visible on mouseover or selected
            // we add it to the first children to get same boxing and position

            obj.children[0].add(obj.tooltip);
          }
        };

        var _wireframe = false; // [jscastro] added property for wireframes state

        define_property_default()(obj, 'wireframe', {
          get: function get() {
            return _wireframe;
          },
          set: function set(value) {
            if (_wireframe !== value) {
              obj.model.traverse(function (c) {
                if (c.type === 'Mesh' || c.type === 'SkinnedMesh') {
                  var arrMaterial = [];

                  if (!is_array_default()(c.material)) {
                    arrMaterial.push(c.material);
                  } else {
                    arrMaterial = c.material;
                  }

                  for_each_default()(arrMaterial).call(arrMaterial, function (m) {
                    m.opacity = value ? 0.5 : 1; //m.transparent = value;

                    m.wireframe = value;
                  });

                  if (value) {
                    c.layers.disable(0);
                    c.layers.enable(1);
                  } else {
                    c.layers.disable(1);
                    c.layers.enable(0);
                  }
                }

                if (c.type === 'LineSegments') {
                  c.layers.disableAll();
                }
              });
              _wireframe = value; // Dispatch new event WireFramed

              obj.dispatchEvent({
                type: 'changed.wireframe'
              });
            }
          }
        });

        var _selected = false; // [jscastro] added property for selected state

        define_property_default()(obj, 'selected', {
          get: function get() {
            return _selected;
          },
          set: function set(value) {
            if (value) {
              if (obj.boundingBox) {
                obj.boundingBox.material = _self.defaults.materials.boxSelectedMaterial;
                obj.boundingBox.parent.visible = true;
                obj.boundingBox.layers.enable(1);
                obj.boundingBoxShadow.layers.enable(1);
              }

              if (obj.label && !obj.label.alwaysVisible) obj.label.visible = true;
            } else {
              if (obj.boundingBox) {
                obj.boundingBox.parent.visible = false;
                obj.boundingBox.layers.disable(1);
                obj.boundingBoxShadow.layers.disable(1);
                obj.boundingBox.material = _self.defaults.materials.boxNormalMaterial;
              }

              if (obj.label && !obj.label.alwaysVisible) obj.label.visible = false;
            }

            if (obj.tooltip) obj.tooltip.visible = value; // only fire the event if value is different

            if (_selected !== value) {
              _selected = value; // Dispatch new event SelectedChange

              obj.dispatchEvent({
                type: 'changed.selected'
              });
            }
          }
        });

        var _hover = false; // [jscastro] added property for hover state

        define_property_default()(obj, 'hover', {
          get: function get() {
            return _hover;
          },
          set: function set(value) {
            if (value) {
              if (!obj.selected) {
                if (obj.boundingBox) {
                  obj.boundingBox.material = _self.defaults.materials.boxOverMaterial;
                  obj.boundingBox.parent.visible = true;
                  obj.boundingBox.layers.enable(1);
                  obj.boundingBoxShadow.layers.enable(1);
                }
              }

              if (obj.label && !obj.label.alwaysVisible) {
                obj.label.visible = true;
              } // Dispatch new event ObjectOver


              obj.dispatchEvent({
                type: 'object.mouseover'
              });
            } else {
              if (!obj.selected) {
                if (obj.boundingBox) {
                  obj.boundingBox.parent.visible = false;
                  obj.boundingBox.layers.disable(1);
                  obj.boundingBoxShadow.layers.disable(1);
                  obj.boundingBox.material = _self.defaults.materials.boxNormalMaterial;
                }

                if (obj.label && !obj.label.alwaysVisible) {
                  obj.label.visible = false;
                }
              } // Dispatch new event ObjectOver


              obj.dispatchEvent({
                type: 'object.mouseout'
              });
            }

            if (obj.tooltip) {
              obj.tooltip.visible = value || obj.selected;
            }

            _hover = value;
          }
        }); // [jscastro] get the object model Box3 in runtime


        obj.box3 = function () {
          // update Matrix and MatrixWorld to avoid issues with transformations not full applied
          obj.updateMatrix();
          obj.updateWorldMatrix(true, true); // obj.updateMatrixWorld(true, true);

          var bounds; // clone also the model inside it's the one who keeps the real size

          if (obj.model) {
            // let's clone the object before manipulate it
            var dup = obj.clone(true);
            dup.model = obj.model.clone(); // get the size of the model because the object is translated and has boundingBoxShadow

            bounds = new three_module["Box3"]().setFromObject(dup.model); // if the object has parent it's already in the added to world so it's scaled and it could be rotated

            if (obj.parent) {
              // first, we return the object to it's original position of rotation, extract rotation and apply inversed
              var rm = new three_module["Matrix4"]();
              var rmi = new three_module["Matrix4"]();
              obj.matrix.extractRotation(rm);
              rm.getInverse(rmi);
              dup.setRotationFromMatrix(rmi); // now the object inside will give us a NAABB Non-Axes Aligned Bounding Box

              bounds = new three_module["Box3"]().setFromObject(dup.model);
            }
          }

          return bounds;
        }; // [jscastro] modelBox


        obj.modelBox = function () {
          return obj.box3();
        };

        obj.getSize = function () {
          return obj.box3().getSize(new three_module["Vector3"](0, 0, 0));
        }; // [jscastro]


        var _modelSize = null; // [jscastro] added property for wireframes state

        define_property_default()(obj, 'modelSize', {
          get: function get() {
            _modelSize = obj.getSize();
            return _modelSize;
          },
          set: function set(value) {
            if (_modelSize != value) {
              _modelSize = value;
            }
          }
        }); // [jscastro]


        obj.modelHeight = 0;
      }

      obj.add = function () {
        _self.threebox.add(obj);

        if (!isStatic) obj.set({
          position: obj.coordinates
        });
        return obj;
      };

      obj.remove = function () {
        _self.threebox.remove(obj);

        map_default()(_self.threebox).repaint = true;
      };

      obj.duplicate = function () {
        var dup = obj.clone();
        dup.userData = obj.userData;

        if (obj.model) {
          dup.model = obj.model.clone();
        }

        _self.addMethods(dup);

        return dup;
      };

      obj.dispose = function () {
        if (obj.label) {
          obj.label.dispose();
        }

        if (obj.tooltip) {
          obj.tooltip.dispose();
        }

        if (obj.model) {
          obj.model = null;
        }
      }; // obj.addListener = (type: ThreeboxEventType, listener: (event: Event) => void) => {
      // 	obj.addEventListener(type, listener);
      // };
      // obj.removeListener = (type: ThreeboxEventType, listener: (event: Event) => void) => {
      // 	obj.removeEventListener(type, listener);
      // };


      return obj;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {(any | any[])} obj
     * @param {*} option
     * @returns
     */

  }, {
    key: "makeGroup",
    value: function makeGroup(obj, option) {
      var geoGroup = new three_module["Group"]();
      geoGroup.userData = option || {};
      geoGroup.userData.isGeoGroup = true;

      if (geoGroup.userData.feature) {
        geoGroup.userData.feature.properties.uuid = geoGroup.uuid;
      }

      if (is_array_default()(obj)) {
        for_each_default()(obj).call(obj, function (o) {
          return geoGroup.add(o);
        });
      } else {
        geoGroup.add(obj);
      }

      this.threebox.utils.flipMaterialSides(obj);
      return geoGroup;
    }
    /**
     * add tooltip method
     *
     * @author salgum1114
     * @param {string} tooltipText
     * @param {boolean} [mapboxStyle=false]
     * @returns
     */

  }, {
    key: "drawTooltip",
    value: function drawTooltip(tooltipText) {
      var mapboxStyle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var divToolTip;

      if (tooltipText) {
        if (mapboxStyle) {
          var divContent = document.createElement('div');
          divContent.className = 'mapboxgl-popup-content';
          var strong = document.createElement('strong');
          strong.innerHTML = tooltipText;
          divContent.appendChild(strong);
          var tip = document.createElement('div');
          tip.className = 'mapboxgl-popup-tip';
          var div = document.createElement('div');
          div.className = 'marker mapboxgl-popup-anchor-bottom';
          div.appendChild(tip);
          div.appendChild(divContent);
          divToolTip = document.createElement('div');
          divToolTip.className += 'label3D';
          divToolTip.appendChild(div);
        } else {
          divToolTip = document.createElement('span');
          divToolTip.className = this.defaults.tooltip.cssClass;
          divToolTip.innerHTML = tooltipText;
        }

        return divToolTip;
      }

      return divToolTip;
    }
    /**
     * draw label method can be invoked separately
     *
     * @author salgum1114
     * @param {(HTMLElement | string)} element
     * @param {string} cssClass
     * @returns
     */

  }, {
    key: "drawLabelHTML",
    value: function drawLabelHTML(element, cssClass) {
      var div = document.createElement('div');
      div.className += cssClass; // [jscastro] create a div [TODO] analize if must be moved

      if (typeof element === 'string') {
        div.innerHTML = element;
      } else {
        div.innerHTML = element.outerHTML;
      }

      return div;
    }
  }]);

  return ObjectHandler;
}();

/* harmony default export */ var handlers_ObjectHandler = (ObjectHandler_ObjectHandler);
// EXTERNAL MODULE: ./node_modules/mapbox-gl/dist/mapbox-gl.js
var mapbox_gl = __webpack_require__(63);
var mapbox_gl_default = /*#__PURE__*/__webpack_require__.n(mapbox_gl);

// CONCATENATED MODULE: ./src/handlers/EventHandler.ts







var EventHandler_EventHandler = /*#__PURE__*/function () {
  // selected object through click
  // dragged object through mousedown + mousemove
  // dragged action to notify frontend
  // overed object through mouseover
  // overed state for extrusion layer features
  // selected state id for extrusion layer features
  // Variable to hold the starting xy coordinates
  // when 'mousedown' occured.
  // degrees step size for rotation
  // decimals to adjust the lnglat
  // when object selected
  // Variable to hold the current xy coordinates
  // when 'mousemove' or 'mouseup' occurs.
  // current;
  // Variable for the draw box element.
  // box;
  // difference between cursor and model left corner
  // difference between cursor and model bottom corner
  function EventHandler(threebox, map) {
    var _this = this;

    classCallCheck_default()(this, EventHandler);

    defineProperty_default()(this, "threebox", void 0);

    defineProperty_default()(this, "map", void 0);

    defineProperty_default()(this, "canvas", void 0);

    defineProperty_default()(this, "selectedObject", void 0);

    defineProperty_default()(this, "draggedObject", void 0);

    defineProperty_default()(this, "draggedAction", void 0);

    defineProperty_default()(this, "overedObject", void 0);

    defineProperty_default()(this, "overedFeature", void 0);

    defineProperty_default()(this, "selectedFeature", void 0);

    defineProperty_default()(this, "start", void 0);

    defineProperty_default()(this, "rotationStep", 10);

    defineProperty_default()(this, "gridStep", 6);

    defineProperty_default()(this, "startCoords", []);

    defineProperty_default()(this, "lngDiff", void 0);

    defineProperty_default()(this, "latDiff", void 0);

    defineProperty_default()(this, "attachEvent", function () {
      map_default()(_this).on('mousedown', _this.handleMouseDown);

      map_default()(_this).on('mouseout', _this.handleMouseOut);

      map_default()(_this).on('mousemove', _this.handleMouseMove);

      map_default()(_this).on('click', _this.handleClick);
    });

    defineProperty_default()(this, "detachEvent", function () {
      map_default()(_this).off('mousedown', _this.handleMouseDown);

      map_default()(_this).off('mouseout', _this.handleMouseOut);

      map_default()(_this).off('mousemove', _this.handleMouseMove);

      map_default()(_this).off('click', _this.handleClick);
    });

    defineProperty_default()(this, "handleClick", function (e) {
      var intersectionExists;
      var intersects = [];

      if (_this.threebox.useSelectingObjects) {
        // raycast only if we are in a custom layer, for other layers go to the else, this avoids duplicated calls to raycaster
        intersects = _this.threebox.queryRenderedFeatures(e.point);
      }

      intersectionExists = typeof_default()(intersects[0]) === 'object'; // if intersect exists, highlight it

      if (intersectionExists) {
        var nearestObject = _this.threebox.findParent3DObject(intersects[0]);

        if (nearestObject) {
          // if extrusion object selected, unselect
          if (_this.selectedFeature) {
            _this.unselectFeature(e.point, _this.selectedFeature);
          } // if not selected yet, select it


          if (!_this.selectedObject) {
            _this.selectedObject = nearestObject;
            _this.selectedObject.selected = true;
          } else if (_this.selectedObject.uuid !== nearestObject.uuid) {
            // it's a different object, restore the previous and select the new one
            _this.selectedObject.selected = false;
            nearestObject.selected = true;
            _this.selectedObject = nearestObject;
          } else if (_this.selectedObject.uuid === nearestObject.uuid) {
            // deselect, reset and return
            _this.unselectObject(_this.selectedObject);

            return;
          } // fire the Wireframed event to notify UI status change


          _this.selectedObject.dispatchEvent({
            type: 'changed.wireframe'
          });

          _this.selectedObject.dispatchEvent({
            type: 'changed.isPlyaing'
          });

          map_default()(_this).repaint = true;
          e.preventDefault();
        }
      } else {
        var features = [];

        if (_this.threebox.useSelectingFeatures) {
          features = map_default()(_this).queryRenderedFeatures(e.point);
        } // now let's check the extrusion layer objects


        if (features.length > 0) {
          if (features[0].layer.type === 'fill-extrusion' && typeof features[0].id !== 'undefined') {
            // if 3D object selected, unselect
            if (_this.selectedObject) {
              _this.unselectObject(_this.selectedObject);
            } // if not selected yet, select it


            if (!_this.selectedFeature) {
              _this.selectFeature(e.point, features[0]);
            } else if (_this.selectedFeature.id !== features[0].id) {
              // it's a different feature, restore the previous and select the new one
              _this.unselectFeature(e.point, _this.selectedFeature);

              _this.selectFeature(e.point, features[0]);
            } else if (_this.selectedFeature.id === features[0].id) {
              // deselect, reset and return
              _this.unselectFeature(e.point, _this.selectedFeature);

              return;
            }
          }
        }
      }
    });

    defineProperty_default()(this, "handleMouseMove", function (e) {
      // Capture the ongoing xy coordinates
      var current = _this.mousePos(e);

      _this.canvas.style.cursor = ''; // check if being rotated

      if (e.originalEvent.altKey && _this.draggedObject) {
        if (!_this.threebox.useRotatingObjects) {
          return;
        }

        _this.draggedAction = 'rotate'; // Set a UI indicator for dragging.

        _this.canvas.style.cursor = 'move'; // const minX = Math.min(start.x, current.x);
        // const maxX = Math.max(start.x, current.x);
        // const minY = Math.min(start.y, current.y);
        // const maxY = Math.max(start.y, current.y);
        // set the movement fluid we rotate only every 10px moved, in steps of 10 degrees up to 360

        var rotation = {
          x: 0,
          y: 0,
          z: 360 + Math.floor((current.x - _this.start.x) / _this.rotationStep) % 360 * _this.rotationStep % 360 // z: 360 + (((~~((current.x - start.x) / rotationStep) % 360) * rotationStep) % 360),

        }; // now rotate the model depending the axis

        _this.draggedObject.setRotation(rotation); // draggedObject.setRotationAxis(rotation);


        return;
      } // check if being moved


      if (e.originalEvent.shiftKey && _this.draggedObject) {
        if (!_this.threebox.useDraggingObjects) {
          return;
        }

        _this.draggedAction = 'translate'; // Set a UI indicator for dragging.

        _this.canvas.style.cursor = 'move'; // Capture the first xy coordinates, height must be the same to move on the same plane

        var coords = e.lngLat;
        var newCoords = [Number((coords.lng + _this.lngDiff).toFixed(_this.gridStep)), Number((coords.lat + _this.latDiff).toFixed(_this.gridStep)), _this.draggedObject.modelHeight];

        _this.draggedObject.setCoords(newCoords);

        return;
      }

      var intersectionExists;
      var intersects = [];

      if (_this.threebox.useSelectingObjects) {
        // calculate objects intersecting the picking ray
        intersects = _this.threebox.queryRenderedFeatures(e.point);
      }

      intersectionExists = typeof_default()(intersects[0]) === 'object'; // if intersect exists, highlight it, if not check the extrusion layer

      if (intersectionExists) {
        var nearestObject = _this.threebox.findParent3DObject(intersects[0]);

        if (nearestObject) {
          _this.unoverFeature(_this.overedFeature);

          _this.canvas.style.cursor = 'pointer';

          if (!_this.selectedObject || nearestObject.uuid !== _this.selectedObject.uuid) {
            if (_this.overedObject) {
              _this.overedObject.hover = false;
              _this.overedObject = null;
            }

            nearestObject.hover = true;
            _this.overedObject = nearestObject;
          }

          map_default()(_this).repaint = true;
          e.preventDefault();
        }
      } else {
        // clean the object overed
        if (_this.overedObject) {
          _this.overedObject.hover = false;
          _this.overedObject = null;
        } // now let's check the extrusion layer objects


        var features = [];

        if (_this.threebox.useSelectingFeatures) {
          features = map_default()(_this).queryRenderedFeatures(e.point);
        }

        if (features.length > 0) {
          _this.unoverFeature(features[0]);

          if (features[0].layer.type === 'fill-extrusion' && typeof features[0].id !== 'undefined') {
            if (!_this.selectedFeature || _this.selectedFeature.id !== features[0].id) {
              _this.canvas.style.cursor = 'pointer';
              _this.overedFeature = features[0];

              map_default()(_this).setFeatureState({
                source: _this.overedFeature.source,
                sourceLayer: _this.overedFeature.sourceLayer,
                id: _this.overedFeature.id
              }, {
                hover: true
              });

              _this.overedFeature = map_default()(_this).queryRenderedFeatures(e.point, {
                layers: [_this.overedFeature.layer.id],
                filter: ['==', ['id'], _this.overedFeature.id]
              })[0]; // overedFeature = _self.map.queryRenderedFeatures({
              // 	layers: [overedFeature.layer.id],
              // 	filter: ['==', ['id'], overedFeature.id],
              // })[0];

              _this.addTooltip(_this.overedFeature);
            }
          }
        }
      }
    });

    defineProperty_default()(this, "handleMouseOut", function (e) {
      if (_this.overedFeature) {
        var features = map_default()(_this).queryRenderedFeatures(e.point);

        if (features.length > 0 && _this.overedFeature.id !== features[0].id) {
          _this.canvas.style.cursor = ''; // only unover when new feature is another

          _this.unoverFeature(features[0]);
        }
      }
    });

    defineProperty_default()(this, "handleMouseDown", function (e) {
      // Continue the rest of the function shiftkey or altkey are pressed, and if object is selected
      if (!((e.originalEvent.shiftKey || e.originalEvent.altKey) && e.originalEvent.button === 0 && _this.selectedObject)) {
        return;
      }

      e.preventDefault();
      _this.canvas.style.cursor = 'move'; // Disable default drag zooming when the shift key is held down.
      // map.dragPan.disable();
      // Call functions for the following events

      map_default()(_this).once('mouseup', _this.handleMouseUp);

      map_default()(_this).once('mouseout', _this.handleMouseUp); // move the selected object


      _this.draggedObject = _this.selectedObject; // Capture the first xy coordinates

      _this.start = _this.mousePos(e);
      _this.startCoords = _this.draggedObject.coordinates;
      _this.lngDiff = _this.startCoords[0] - e.lngLat.lng;
      _this.latDiff = _this.startCoords[1] - e.lngLat.lat;
    });

    defineProperty_default()(this, "handleMouseUp", function () {
      // Set a UI indicator for dragging.
      _this.canvas.style.cursor = ''; // Remove these events now that finish has been called.
      // map.off('mousemove', onMouseMove);

      map_default()(_this).off('mouseup', _this.handleMouseUp);

      map_default()(_this).off('mouseout', _this.handleMouseUp);

      map_default()(_this).dragPan.enable();

      if (_this.draggedObject) {
        _this.draggedObject.dispatchEvent({
          type: 'object.dragged',
          draggedAction: _this.draggedAction
        });

        _this.draggedObject = null;
        _this.draggedAction = null;
      }
    });

    this.threebox = threebox;
    this.map = map;
    this.canvas = map.getCanvasContainer();
    this.canvas.style.cursor = '';
    this.attachEvent();
  }

  createClass_default()(EventHandler, [{
    key: "mousePos",
    // Return the xy coordinates of the mouse position
    value: function mousePos(e) {
      var rect = this.canvas.getBoundingClientRect();
      return new mapbox_gl_default.a.Point(e.originalEvent.clientX - rect.left - this.canvas.clientLeft, e.originalEvent.clientY - rect.top - this.canvas.clientTop);
    }
  }, {
    key: "unselectFeature",
    value: function unselectFeature(point, feature) {
      if (typeof feature.id === 'undefined') {
        return;
      }

      map_default()(this).setFeatureState({
        source: feature.source,
        sourceLayer: feature.sourceLayer,
        id: feature.id
      }, {
        select: false
      });

      this.removeTooltip(feature);
      feature = map_default()(this).queryRenderedFeatures(point, {
        layers: [feature.layer.id],
        filter: ['==', ['id'], feature.id]
      })[0]; // Dispatch new event f for unselected

      if (feature) {
        map_default()(this).fire('SelectedFeatureChange', {
          detail: feature
        });
      }

      this.selectedFeature = null;
    }
  }, {
    key: "selectFeature",
    value: function selectFeature(point, feature) {
      this.selectedFeature = feature;

      map_default()(this).setFeatureState({
        source: this.selectedFeature.source,
        sourceLayer: this.selectedFeature.sourceLayer,
        id: this.selectedFeature.id
      }, {
        select: true
      });

      this.selectedFeature = map_default()(this).queryRenderedFeatures(point, {
        layers: [this.selectedFeature.layer.id],
        filter: ['==', ['id'], this.selectedFeature.id]
      })[0];
      this.addTooltip(this.selectedFeature); // Dispatch new event SelectedFeature for selected

      map_default()(this).fire('SelectedFeatureChange', {
        detail: this.selectedFeature
      });
    }
  }, {
    key: "unoverFeature",
    value: function unoverFeature(feature) {
      if (this.overedFeature && typeof this.overedFeature !== 'undefined' && this.overedFeature.id !== feature.id) {
        // if (overedFeature && typeof overedFeature !== 'undefined' && overedFeature.id != f) {
        map_default()(this).setFeatureState({
          source: this.overedFeature.source,
          sourceLayer: this.overedFeature.sourceLayer,
          id: this.overedFeature.id
        }, {
          hover: false
        });

        this.removeTooltip(this.overedFeature);
        this.overedFeature = null;
      }
    }
  }, {
    key: "unselectObject",
    value: function unselectObject(object) {
      // deselect, reset and return
      object.selected = false;
      console.log(object.selected);
      this.selectedObject = null;
    }
  }, {
    key: "addTooltip",
    value: function addTooltip(_feature) {// if (!this.threebox.useTooltip) {
      // 	return;
      // }
      // const coordinates = this.threebox.getFeatureCenter(feature);
      // const tooltipObj = this.threebox.tooltip({
      // 	text: feature.properties.name || feature.id || feature.type,
      // 	mapboxStyle: true,
      // 	feature,
      // });
      // tooltipObj.setCoords(coordinates);
      // this.threebox.add(tooltipObj);
      // tooltipObj.tooltip = tooltipObj;
      // tooltipObj.tooltip.tooltip.visible = true;
    }
  }, {
    key: "removeTooltip",
    value: function removeTooltip(_feature) {// if (feature.tooltip) {
      // 	feature.tooltip.visibility = false;
      // 	this.threebox.remove(feature.tooltip);
      // 	feature.tooltip = null;
      // }
    }
  }]);

  return EventHandler;
}();

/* harmony default export */ var handlers_EventHandler = (EventHandler_EventHandler);
// CONCATENATED MODULE: ./src/handlers/AnimationHandler.ts









var AnimationHandlerDefaultOption = {
  followPath: {
    path: null,
    duration: 1000,
    trackHeading: true
  }
};

var AnimationHandler_AnimationHandler = function AnimationHandler(threebox, map) {
  var _this = this;

  classCallCheck_default()(this, AnimationHandler);

  defineProperty_default()(this, "map", void 0);

  defineProperty_default()(this, "threebox", void 0);

  defineProperty_default()(this, "enrolledObjects", void 0);

  defineProperty_default()(this, "previousFrameTime", void 0);

  defineProperty_default()(this, "enroll", function (obj) {
    var _self = _this; // [jscastro] add the object default animations

    obj.clock = new three_module["Clock"]();
    obj.hasDefaultAnimation = false;
    obj.defaultAction = undefined;
    obj.actions = [];
    obj.mixer = undefined; // [jscastro] if the object includes animations

    if (obj.animations && obj.animations.length > 0) {
      obj.hasDefaultAnimation = true; // check first if a defaultAnimation is defined by options

      var daIndex = obj.userData.defaultAnimation ? obj.userData.defaultAnimation : 0;
      obj.mixer = new three_module["AnimationMixer"](obj);
      setAction(daIndex);
    } // [jscastro] set the action to play


    function setAction(animationIndex) {
      for (var i = 0; i < obj.animations.length; i++) {
        if (animationIndex > obj.animations.length) {
          console.log("The animation index ".concat(animationIndex, " doesn't exist for this object"));
        }

        var animation = obj.animations[i];
        var action = obj.mixer.clipAction(animation);
        obj.actions.push(action); // select the default animation and set the weight to 1

        if (animationIndex === i) {
          obj.defaultAction = action;
          action.setEffectiveWeight(1);
        } else {
          action.setEffectiveWeight(0);
        }

        action.play();
      }
    }

    var _isPlaying = false; // [jscastro] added property for isPlaying state

    define_property_default()(obj, 'isPlaying', {
      get: function get() {
        return _isPlaying;
      },
      set: function set(value) {
        if (_isPlaying != value) {
          _isPlaying = value; // Dispatch new event IsPlayingChanged

          obj.dispatchEvent({
            type: 'changed.isPlyaing'
          });
        }
      }
    });
    /* Extend the provided object with animation-specific properties and track in the animation manager */


    _this.enrolledObjects.push(obj); // Give this object its own internal animation queue


    obj.animationQueue = [];

    obj.set = function (option) {
      // if duration is set, animate to the new state
      if (option.duration > 0) {
        var newParams = {
          start: now_default()(),
          expiration: now_default()() + option.duration,
          endState: {}
        };

        _self.threebox.utils.extend(option, newParams);

        var translating = option.coords;
        var rotating = option.rotation;
        var scaling = option.scale || option.scaleX || option.scaleY || option.scaleZ;

        if (rotating) {
          var _context;

          var r = obj.rotation;
          option.startRotation = [r.x, r.y, r.z];
          option.endState.rotation = _self.threebox.utils.rotation(option.rotation, option.startRotation);
          option.rotationPerMs = map_default()(_context = option.endState.rotation).call(_context, function (angle, index) {
            return (angle - option.startRotation[index]) / option.duration;
          });
        }

        if (scaling) {
          var _context2;

          var s = obj.scale;
          option.startScale = [s.x, s.y, s.z];
          option.endState.scale = _self.threebox.utils.scale(option.scale, option.startScale);
          option.scalePerMs = map_default()(_context2 = option.endState.scale).call(_context2, function (scale, index) {
            return (scale - option.startScale[index]) / option.duration;
          });
        }

        if (translating) {
          option.pathCurve = new three_module["CatmullRomCurve3"](_self.threebox.utils.lnglatsToWorld([obj.coordinates, option.coords]));
        }

        var entry = {
          type: 'set',
          parameters: option
        };
        obj.animationQueue.push(entry);
        map_default()(_self).repaint = true;
      } else {
        // if no duration set, stop object's existing animations and go to that state immediately
        obj.stop();
        option.rotation = _self.threebox.utils.radify(option.rotation);
        obj.setObject(option);
      }

      return _this;
    }; // [jscastro] animation method, is set by update method


    obj.animationMethod = null; // [jscastro] stop animation and the queue

    obj.stop = function (_index) {
      if (obj.mixer) {
        obj.isPlaying = false;
        cancelAnimationFrame(obj.animationMethod);
      } // TODO: if this is removed, it produces an error in


      obj.animationQueue = [];
      return _this;
    };

    obj.followPath = function (option, callback) {
      var entry = {
        type: 'followPath',
        parameters: _self.threebox.utils.validate(option, AnimationHandlerDefaultOption.followPath)
      };

      _self.threebox.utils.extend(entry.parameters, {
        pathCurve: new three_module["CatmullRomCurve3"](_self.threebox.utils.lnglatsToWorld(option.path)),
        start: now_default()(),
        expiration: now_default()() + entry.parameters.duration,
        callback: callback
      });

      obj.animationQueue.push(entry);
      map_default()(_self).repaint = true;
      return _this;
    };

    obj.setObject = function (option) {
      var p = option.position; // lnglat

      var r = option.rotation; // radians

      var s = option.scale;
      var w = option.worldCoordinates; // Vector3

      var q = option.quaternion; // [axis, angle in rads]

      var t = option.translate; // [jscastro] lnglat + height for 3D objects

      if (p) {
        obj.coordinates = p;

        var c = _self.threebox.utils.projectToWorld(p);

        obj.position.copy(c);
      }

      if (t) {
        obj.coordinates = [obj.coordinates[0] + t[0], obj.coordinates[1] + t[1], obj.coordinates[2] + t[2]];

        var _c = _self.threebox.projectToWorld(t);

        obj.translateX(_c.x);
        obj.translateY(_c.y);
        obj.translateZ(_c.z);
      }

      if (r) {
        obj.rotation.set(r[0], r[1], r[2]);
      }

      if (s) {
        obj.scale.set(s[0], s[1], s[2]);
      }

      if (q) {
        obj.quaternion.setFromAxisAngle(q[0], q[1]);
      }

      if (w) {
        obj.position.copy(w);
      }

      obj.updateMatrixWorld();
      map_default()(_self).repaint = true;
    }; // [jscastro] play default animation


    obj.playDefault = function (option) {
      if (obj.mixer && obj.hasDefaultAnimation) {
        var newParams = {
          start: now_default()(),
          expiration: now_default()() + option.duration,
          endState: {}
        };

        _self.threebox.utils.extend(option, newParams);

        var entry = {
          type: 'playDefault',
          parameters: option
        };
        obj.animationQueue.push(entry);
        map_default()(_self).repaint = true;
        return obj;
      }

      return null;
    }; // [jscastro] play an animation, requires options.animation as an index, if not it will play the default one


    obj.playAnimation = function (option) {
      if (obj.mixer) {
        if (option.animation) {
          setAction(option.animation);
        }

        obj.playDefault(option);
      }
    }; // [jscastro] pause all actions animation


    obj.pauseAllActions = function () {
      if (obj.mixer) {
        var _context3;

        for_each_default()(_context3 = obj.actions).call(_context3, function (action) {
          action.paused = true;
        });
      }
    }; // [jscastro] resume all actions


    obj.resumeAllActions = function () {
      if (obj.mixer) {
        var _context4;

        for_each_default()(_context4 = obj.actions).call(_context4, function (action) {
          action.paused = false;
        });
      }
    }; // [jscastro] stop all actions


    obj.deactivateAllActions = function () {
      if (obj.mixer) {
        var _context5;

        for_each_default()(_context5 = obj.actions).call(_context5, function (action) {
          action.stop();
        });
      }
    }; // [jscastro] play all actions


    obj.activateAllActions = function () {
      if (obj.mixer) {
        var _context6;

        for_each_default()(_context6 = obj.actions).call(_context6, function (action) {
          action.play();
        });
      }
    }; // [jscastro] move the model action one tick just to avoid issues with initial position


    obj.idle = function () {
      if (obj.mixer) {
        // Update the animation mixer and render this frame
        obj.mixer.update(0.01);
      }

      map_default()(_self).repaint = true;
      return _this;
    };
  });

  defineProperty_default()(this, "update", function (now) {
    if (_this.previousFrameTime === undefined) {
      _this.previousFrameTime = now;
    } // TODO...
    // const dimensions = ['X', 'Y', 'Z'];
    // [jscastro] when function expires this produces an error


    if (!_this.enrolledObjects) {
      return false;
    } // iterate through objects in queue. count in reverse so we can cull objects without frame shifting


    for (var a = _this.enrolledObjects.length - 1; a >= 0; a--) {
      var object = _this.enrolledObjects[a];

      if (!object.animationQueue || object.animationQueue.length === 0) {
        continue;
      } // [jscastro] now multiple animations on a single object is possible


      var _loop = function _loop(i) {
        // focus on first item in queue
        var item = object.animationQueue[i];

        if (!item) {
          return "continue";
        }

        var option = item.parameters; // if an animation is past its expiration date, cull it

        if (!option.expiration) {
          var _context7;

          splice_default()(_context7 = object.animationQueue).call(_context7, i, 1); // set the start time of the next animation


          if (object.animationQueue[i]) {
            object.animationQueue[i].parameters.start = now;
          }

          return {
            v: false
          };
        } // if finished, jump to end state and flag animation entry for removal next time around. Execute callback if there is one


        var expiring = now >= option.expiration;

        if (expiring) {
          option.expiration = false;

          if (item.type === 'playDefault') {
            object.stop();
          } else {
            if (option.endState) object.setObject(option.endState);
            if (typeof option.callback !== 'undefined') option.callback();
          }
        } else {
          var timeProgress = (now - option.start) / option.duration;
          var objectState = {};

          if (item.type === 'set') {
            if (option.pathCurve) {
              objectState.worldCoordinates = option.pathCurve.getPoint(timeProgress);
            }

            if (option.rotationPerMs) {
              var _context8;

              objectState.rotation = map_default()(_context8 = option.startRotation).call(_context8, function (rad, index) {
                return rad + option.rotationPerMs[index] * timeProgress * option.duration;
              });
            }

            if (option.scalePerMs) {
              var _context9;

              objectState.scale = map_default()(_context9 = option.startScale).call(_context9, function (scale, index) {
                return scale + option.scalePerMs[index] * timeProgress * option.duration;
              });
            }

            object.setObject(objectState);
          }

          if (item.type === 'followPath') {
            var position = option.pathCurve.getPointAt(timeProgress);
            objectState = {
              worldCoordinates: position
            }; // if we need to track heading

            if (option.trackHeading) {
              var tangent = option.pathCurve.getTangentAt(timeProgress).normalize();
              var axis = new three_module["Vector3"](0, 0, 0);
              var up = new three_module["Vector3"](0, 1, 0);
              axis.crossVectors(up, tangent).normalize();
              var radians = Math.acos(up.dot(tangent));
              objectState.quaternion = [axis, radians];
            }

            object.setObject(objectState);
          } // [jscastro] play default animation


          if (item.type === 'playDefault') {
            object.activateAllActions();
            object.isPlaying = true;
            object.animationMethod = requestAnimationFrame(_this.update);
            object.mixer.update(object.clock.getDelta());
            map_default()(_this).repaint = true;
          }
        }
      };

      for (var i = object.animationQueue.length - 1; i >= 0; i--) {
        var _ret = _loop(i);

        if (_ret === "continue") continue;
        if (typeof_default()(_ret) === "object") return _ret.v;
      }
    }

    _this.previousFrameTime = now;
    return true;
  });

  this.map = map;
  this.threebox = threebox;
  this.previousFrameTime = undefined;
  this.enrolledObjects = [];
};

/* harmony default export */ var handlers_AnimationHandler = (AnimationHandler_AnimationHandler);
// CONCATENATED MODULE: ./src/Threebox.ts




















var ThreeboxDefaultOption = {
  outputEncoding: three_module["GammaEncoding"],
  gammaFactor: 2,
  passiveRendering: true,
  useDefaultLights: true,
  useTooltip: false,
  useHover: false,
  useSelectingObjects: false,
  useSelectingFeatures: false,
  useRotatingObjects: false,
  useDraggingObjects: false
};
var LoadModelDefaultOption = {
  url: null,
  type: null,
  units: 'meters',
  scale: 1,
  rotation: {
    x: 90,
    y: 0,
    z: 0
  },
  defaultAnimation: 0,
  adjustment: {
    x: 0,
    y: 0,
    z: 0
  },
  normalize: false
};

var Threebox_Threebox = /*#__PURE__*/function () {
  // TODO...
  // import package.json version
  // Threebox options
  // Threebox utils

  /**
   * Creates an instance of Threebox.
   * @author salgum1114
   * @param {mapboxgl.Map} map
   * @param {WebGLRenderingContext} gl
   * @param {ThreeboxOption} [option]
   */
  function Threebox(map, gl, option) {
    classCallCheck_default()(this, Threebox);

    defineProperty_default()(this, "version", '1.0.0');

    defineProperty_default()(this, "map", void 0);

    defineProperty_default()(this, "gl", void 0);

    defineProperty_default()(this, "scene", void 0);

    defineProperty_default()(this, "camera", void 0);

    defineProperty_default()(this, "renderer", void 0);

    defineProperty_default()(this, "raycaster", void 0);

    defineProperty_default()(this, "world", void 0);

    defineProperty_default()(this, "objectsCache", void 0);

    defineProperty_default()(this, "cameraSync", void 0);

    defineProperty_default()(this, "labelRenderer", void 0);

    defineProperty_default()(this, "option", void 0);

    defineProperty_default()(this, "useTooltip", void 0);

    defineProperty_default()(this, "useDefaultLights", void 0);

    defineProperty_default()(this, "useHover", void 0);

    defineProperty_default()(this, "useSelectingObjects", void 0);

    defineProperty_default()(this, "useSelectingFeatures", void 0);

    defineProperty_default()(this, "useRotatingObjects", void 0);

    defineProperty_default()(this, "useDraggingObjects", void 0);

    defineProperty_default()(this, "utils", src_Utils);

    defineProperty_default()(this, "material", void 0);

    defineProperty_default()(this, "events", void 0);

    defineProperty_default()(this, "objects", void 0);

    defineProperty_default()(this, "animations", void 0);

    this.map = map;
    this.gl = gl; // apply start option

    this.option = this.utils.validate(option || {}, ThreeboxDefaultOption);
    this.material = src_Material;
    this.objects = new handlers_ObjectHandler(this, map);
    this.events = new handlers_EventHandler(this, map);
    this.animations = new handlers_AnimationHandler(this, map); // Set up WebGLRenderer

    this.renderer = new three_module["WebGLRenderer"]({
      canvas: map.getCanvas(),
      antialias: true,
      context: gl
    }); // this.renderer.setPixelRatio(globalThis.devicePixelRatio);

    this.renderer.setSize(map.getCanvas().clientWidth, map.getCanvas().clientHeight);
    this.renderer.autoClear = false;
    this.renderer.outputEncoding = (option === null || option === void 0 ? void 0 : option.outputEncoding) || three_module["GammaEncoding"];
    this.renderer.gammaFactor = (option === null || option === void 0 ? void 0 : option.gammaFactor) || 2; // [jscastro] set labelRendered
    // this.labelRenderer = new LabelRenderer(this.map);
    // create Scene

    this.scene = new three_module["Scene"](); // create Perspective camera

    this.camera = new three_module["PerspectiveCamera"](src_Constant.FOV_DEGREES, map.getCanvas().clientWidth / map.getCanvas().clientHeight, 1, 1e21);
    this.camera.layers.enable(0);
    this.camera.layers.enable(1); // The CameraSync object will keep the Mapbox and THREE.js camera movements in sync.
    // It requires a world group to scale as we zoom in. Rotation is handled in the camera's
    // projection matrix itself (as is field of view and near/far clipping)
    // It automatically registers to listen for move events on the map so we don't need to do that here

    this.world = new three_module["Group"]();
    this.scene.add(this.world);
    this.objectsCache = [];
    this.cameraSync = new src_CameraSync(map_default()(this), this.camera, this.world); // raycaster for mouse events

    this.raycaster = new three_module["Raycaster"]();
    this.raycaster.layers.set(0); // set up event option

    this.setEventOption(this.option); // create default lights

    this.defaultLights();
  }

  createClass_default()(Threebox, [{
    key: "setEventOption",
    value: function setEventOption(option) {
      this.useDefaultLights = this.option.useDefaultLights;
      this.useTooltip = option.useTooltip;
      this.useHover = option.useHover;
      this.useSelectingFeatures = option.useSelectingFeatures;
      this.useSelectingObjects = option.useSelectingObjects;
      this.useDraggingObjects = option.useDraggingObjects;
    }
    /**
     *
     *
     * @author salgum1114
     */

  }, {
    key: "defaultLights",
    value: function defaultLights() {
      if (this.useDefaultLights) {
        var ambientLight = new three_module["AmbientLight"](new three_module["Color"]('hsl(0, 0%, 100%)'), 0.75);
        this.scene.add(ambientLight);
        var directionalLightBack = new three_module["DirectionalLight"](new three_module["Color"]('hsl(0, 0%, 100%)'), 0.25);
        directionalLightBack.position.set(10, 100, 100);
        this.scene.add(directionalLightBack);
        var directionalLightFront = new three_module["DirectionalLight"](new three_module["Color"]('hsl(0, 0%, 100%)'), 0.25);
        directionalLightFront.position.set(-10, -100, 100);
        this.scene.add(directionalLightFront);
      }
    }
    /**
     *
     *
     * @author salgum1114
     * @returns
     */

  }, {
    key: "memory",
    value: function memory() {
      return this.renderer.info.memory;
    }
    /**
     *
     *
     * @author salgum1114
     * @returns
     */

  }, {
    key: "programs",
    value: function programs() {
      return this.renderer.info.programs.length;
    }
    /**
     *
     *
     * @author salgum1114
     * @param {[number, number, number]} coords
     * @returns
     */

  }, {
    key: "projectToWorld",
    value: function projectToWorld(coords) {
      return this.utils.projectToWorld(coords);
    }
    /**
     *
     *
     * @author salgum1114
     * @param {{ x: number; y: number; z: number }} v3
     * @returns
     */

  }, {
    key: "unprojectFromWorld",
    value: function unprojectFromWorld(v3) {
      return this.utils.unprojectFromWorld(v3);
    }
    /**
     *
     *
     * @author salgum1114
     * @param {number} lat
     * @returns
     */

  }, {
    key: "projectedUnitsPerMeter",
    value: function projectedUnitsPerMeter(lat) {
      return this.utils.projectedUnitsPerMeter(lat);
    }
    /**
     * get the center point of a feature
     *
     * @author salgum1114
     * @param {GeoJSON.Feature<any>} feature
     * @param {ThreeboxObject} obj
     * @param {number} level
     * @returns
     */

  }, {
    key: "getFeatureCenter",
    value: function getFeatureCenter(feature, obj, level) {
      return this.utils.getFeatureCenter(feature, obj, level);
    }
    /**
     *
     *
     * @author salgum1114
     * @param {GeoJSON.Feature<any>} feature
     * @param {ThreeboxObject} [obj]
     * @param {number} [level]
     * @returns
     */

  }, {
    key: "getObjectHeightOnFloor",
    value: function getObjectHeightOnFloor(feature, obj, level) {
      return this.utils.getObjectHeightOnFloor(feature, obj, level);
    }
    /**
     *
     *
     * @author salgum1114
     * @param {mapboxgl.Point} point
     * @returns
     */

  }, {
    key: "queryRenderedFeatures",
    value: function queryRenderedFeatures(point) {
      var map = map_default()(this);

      var mouse = new three_module["Vector2"](); // // scale mouse pixel position to a percentage of the screen's width and height

      mouse.x = point.x / map.transform.width * 2 - 1;
      mouse.y = 1 - point.y / map.transform.height * 2;
      this.raycaster.setFromCamera(mouse, this.camera); // calculate objects intersecting the picking ray

      var intersects = this.raycaster.intersectObjects(this.world.children, true);
      return intersects;
    }
    /**
     * find 3D object of a mesh. this method is needed to know the object of a raycasted mesh
     *
     * @author salgum1114
     * @param {Intersection} mesh
     * @returns
     */

  }, {
    key: "findParent3DObject",
    value: function findParent3DObject(mesh) {
      // find the Parent Object3D of the mesh captured by Raytracer
      var result;
      mesh.object.traverseAncestors(function (m) {
        if (m.parent) {
          if (m.parent.type === 'Group' && m.userData.url) {
            result = m;
          }
        }
      });
      return result;
    }
    /**
     * method to replicate behaviour of map.setLayoutProperty when Threebox are affected
     *
     * @author salgum1114
     * @param {string} layerId
     * @param {string} name
     * @param {*} value
     * @returns
     */

  }, {
    key: "setLayoutProperty",
    value: function setLayoutProperty(layerId, name, value) {
      // first set layout property at the map
      map_default()(this).setLayoutProperty(layerId, name, value);

      if (value !== null && value !== undefined) {
        if (name === 'visibility') {
          var _context;

          for_each_default()(_context = this.world.children).call(_context, function (obj) {
            if (obj.userData.feature && obj.userData.feature.layer === layerId) {
              obj.visibility = value;
            }
          });

          return;
        }
      }
    }
    /**
     * Custom Layers doesn't work on minzoom and maxzoom attributes, and if the layer is including labels they don't hide either on minzoom
     *
     * @author salgum1114
     * @param {string} layer3d
     * @param {number} minZoomLayer
     * @param {number} maxZoomLayer
     */

  }, {
    key: "setLayerZoomRange",
    value: function setLayerZoomRange(layer3d, minZoomLayer, maxZoomLayer) {
      if (map_default()(this).getLayer(layer3d)) {
        map_default()(this).setLayerZoomRange(layer3d, minZoomLayer, maxZoomLayer);

        this.setLabelZoomRange(minZoomLayer, maxZoomLayer);
      }
    }
    /**
     * method to set the height of all the objects in a level. this only works if the objects have a geojson feature
     *
     * @author salgum1114
     * @param {string} layerId
     * @param {number} level
     * @returns
     */

  }, {
    key: "setLayerHeigthProperty",
    value: function setLayerHeigthProperty(layerId, level) {
      var _this = this;

      var map = map_default()(this);

      var layer = map.getLayer(layerId);
      if (!layer) return;

      if (layer.type === 'fill-extrusion') {
        var data = map.getStyle().sources[layer.source].data;
        var features = data.features;

        for_each_default()(features).call(features, function (f) {
          f.properties.level = level;
        }); // we change the level on the source


        map.getSource(layer.source).setData(data);
      } else if (layer.type === 'custom') {
        var _context2;

        for_each_default()(_context2 = this.world.children).call(_context2, function (obj) {
          var feature = obj.userData.feature;

          if (feature && feature.layer === layerId) {
            // TODO...
            // this could be a multidimensional array
            var location = _this.utils.getFeatureCenter(feature, obj, level);

            obj.setCoords(location);
          }
        });
      }
    }
    /**
     * method to toggle Layer visibility
     *
     * @author salgum1114
     * @param {string} layerId
     * @param {boolean} visible
     */

  }, {
    key: "toggleLayer",
    value: function toggleLayer(layerId, visible) {
      if (map_default()(this).getLayer(layerId)) {
        this.setLayoutProperty(layerId, 'visibility', visible ? 'visible' : 'none');
      }
    }
    /**
     * method set the CSS2DObjects zoom range and hide them at the same time the layer is
     *
     * @deprecated
     * @author salgum1114
     * @param {number} minZoom
     * @param {number} maxZoom
     */

  }, {
    key: "setLabelZoomRange",
    value: function setLabelZoomRange(minZoom, maxZoom) {
      console.warn('[DEPRECATED] Not used', minZoom, maxZoom); // this.labelRenderer.setZoomRange(minZoom, maxZoom);
    }
    /**
     * Update scene
     *
     * @author salgum1114
     */

  }, {
    key: "update",
    value: function update() {
      if (map_default()(this).repaint) {
        map_default()(this).repaint = false;
      }

      var timestamp = now_default()(); // Update any animations


      this.animations.update(timestamp);
      this.renderer.state.reset(); // Render the scene and repaint the map

      this.renderer.render(this.scene, this.camera); // [jscastro] Render any label
      // this.labelRenderer.render(this.scene, this.camera);

      if (this.option.passiveRendering === false) {
        map_default()(this).triggerRepaint();
      }
    }
  }, {
    key: "add",
    value: function add(obj) {
      // [jscastro] remove the tooltip if not enabled
      if (!this.useTooltip && obj.tooltip) {
        obj.tooltip.visibility = false;
      }

      this.world.add(obj);
    }
  }, {
    key: "remove",
    value: function remove(obj) {
      // [jscastro] remove also the label if exists dispatching the event removed to fire CSS2DRenderer "removed" listener
      if (obj.label) {
        obj.label.remove();
      }

      if (obj.tooltip) {
        obj.tooltip.remove();
      }

      this.world.remove(obj);
    }
    /**
     * method to fully dispose the resources, watch out is you call this without navigating to other page
     *
     * @author salgum1114
     * @returns
     */

  }, {
    key: "dispose",
    value: function dispose() {
      var _this2 = this;

      console.log(this.memory());
      return new promise_default.a(function (resolve) {
        _this2.world.traverse(function (obj) {
          if (obj.geometry) {
            obj.geometry.dispose();
          }

          if (obj.material) {
            if (obj.material instanceof three_module["Mesh"]) {
              var _context3;

              for_each_default()(_context3 = obj.material.materials).call(_context3, function (m) {
                m.dispose();

                if (map_default()(m)) {
                  map_default()(m).dispose();
                }
              });
            } else {
              obj.material.dispose();
            }

            var m = obj.material;
            var md = map_default()(m) || m.alphaMap || m.aoMap || m.bumpMap || m.displacementMap || m.emissiveMap || m.envMap || m.lightMap || m.metalnessMap || m.normalMap || m.roughnessMap;

            if (md) {
              if (map_default()(m)) {
                map_default()(m).dispose();
              }

              if (m.alphaMap) {
                m.alphaMap.dispose();
              }

              if (m.aoMap) {
                m.aoMap.dispose();
              }

              if (m.bumpMap) {
                m.bumpMap.dispose();
              }

              if (m.displacementMap) {
                m.displacementMap.dispose();
              }

              if (m.emissiveMap) {
                m.emissiveMap.dispose();
              }

              if (m.envMap) {
                m.envMap.dispose();
              }

              if (m.lightMap) {
                m.lightMap.dispose();
              }

              if (m.metalnessMap) {
                m.metalnessMap.dispose();
              }

              if (m.normalMap) {
                m.normalMap.dispose();
              }

              if (m.roughnessMap) {
                m.roughnessMap.dispose();
              }
            }
          }

          if (obj.dispose) {
            obj.dispose();
          }
        }); // this.map.remove();
        // this.map = {};


        _this2.scene.remove(_this2.world);

        _this2.scene.dispose();

        _this2.world.children = [];
        _this2.world = null; // this.labelRenderer.dispose();

        console.log(_this2.memory());

        _this2.renderer.dispose();

        resolve(true);
      });
    }
  }, {
    key: "loadModel",
    value: function () {
      var _loadModel = asyncToGenerator_default()( /*#__PURE__*/regenerator_default.a.mark(function _callee(option) {
        var _option, loader, mtlLoader, materials, objLoader, obj, group, animations, r, s, projScaleGroup, userScaleGroup, center, size, boxGrid, normalizeSpecular;

        return regenerator_default.a.wrap(function _callee$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                normalizeSpecular = function _normalizeSpecular(model) {
                  model.traverse(function (c) {
                    if (c.isMesh) {
                      var specularColor;

                      if (c.material.type === 'MeshStandardMaterial') {
                        if (c.material.metalness) {
                          c.material.metalness *= 0.1;
                        }

                        if (c.material.glossiness) {
                          c.material.glossiness *= 0.25;
                        }

                        specularColor = new three_module["Color"](12, 12, 12);
                      } else if (c.material.type === 'MeshPhongMaterial') {
                        c.material.shininess = 0.1;
                        specularColor = new three_module["Color"](20, 20, 20);
                      }

                      if (c.material.specular && c.material.specular.isColor) {
                        c.material.specular = specularColor;
                      }
                    }
                  });
                };

                if (option.type) {
                  _context4.next = 4;
                  break;
                }

                console.warn('[WARNING] Required type option', option);
                return _context4.abrupt("return", promise_default.a.reject());

              case 4:
                _option = this.utils.validate(option, LoadModelDefaultOption);
                _context4.t0 = _option.type;
                _context4.next = _context4.t0 === 'obj' ? 8 : _context4.t0 === 'gltf' ? 10 : _context4.t0 === 'fbx' ? 12 : _context4.t0 === 'dae' ? 14 : 16;
                break;

              case 8:
                // TODO: Support formats other than OBJ/MTL
                loader = new OBJLoader["a" /* OBJLoader */]();
                return _context4.abrupt("break", 16);

              case 10:
                // [jscastro] Support for GLTF
                loader = new GLTFLoader["a" /* GLTFLoader */]();
                return _context4.abrupt("break", 16);

              case 12:
                loader = new FBXLoader["a" /* FBXLoader */]();
                return _context4.abrupt("break", 16);

              case 14:
                loader = new ColladaLoader["a" /* ColladaLoader */]();
                return _context4.abrupt("break", 16);

              case 16:
                if (!(_option.type === 'obj')) {
                  _context4.next = 22;
                  break;
                }

                mtlLoader = new MTLLoader["a" /* MTLLoader */]();
                _context4.next = 20;
                return mtlLoader.loadAsync(_option.mtl);

              case 20:
                materials = _context4.sent;

                if (materials && _option.type === 'obj') {
                  materials.preload();
                  objLoader = loader;
                  objLoader.setMaterials(materials);
                }

              case 22:
                _context4.next = 24;
                return loader.loadAsync(_option.url);

              case 24:
                obj = _context4.sent;
                group = obj; // [jscastro] MTL/GLTF/FBX models have a different structure

                _context4.t1 = _option.type;
                _context4.next = _context4.t1 === 'obj' ? 29 : _context4.t1 === 'gltf' ? 31 : _context4.t1 === 'dae' ? 31 : _context4.t1 === 'fbx' ? 34 : 36;
                break;

              case 29:
                group = obj.children[0];
                return _context4.abrupt("break", 36);

              case 31:
                animations = obj.animations;
                group = obj.scene;
                return _context4.abrupt("break", 36);

              case 34:
                animations = obj.animations;
                return _context4.abrupt("break", 36);

              case 36:
                // [jscastro] options.rotation was wrongly used
                r = this.utils.rotation(_option.rotation, [0, 0, 0]);
                s = this.utils.scale(_option.scale, [1, 1, 1]);
                group.rotation.set(r[0], r[1], r[2]);
                group.scale.set(s[0], s[1], s[2]); // [jscastro] normalize specular/metalness/shininess from meshes in FBX and GLB model as it would need 5 lights to illuminate them properly

                if (_option.normalize) {
                  normalizeSpecular(group);
                }

                projScaleGroup = new three_module["Group"]();
                projScaleGroup.add(group);
                userScaleGroup = this.objects.makeGroup(projScaleGroup, _option);
                userScaleGroup.model = group; // [jscastro] assign the animations to the userScaleGroup before enrolling it in AnimationsManager through _addMethods

                userScaleGroup.animations = animations;
                this.objects.addMethods(userScaleGroup); // [jscastro] if the object options have an adjustment to center the 3D Object

                center = _option.adjustment;

                if (center) {
                  size = userScaleGroup.getSize();
                  group.position.set(size.x * center.x, size.y * center.y, size.z * center.z);
                } // [jscastro] after adding methods create the bounding box at userScaleGroup but add it to its children for positioning


                boxGrid = userScaleGroup.drawBoundingBox();
                projScaleGroup.add(boxGrid); // [jscastro] we add by default a tooltip that can be override later or hide it with threebox `enableTooltips`

                userScaleGroup.addTooltip(userScaleGroup.uuid, true, center); // [jscastro] initialize the default animation to avoid issues with position

                userScaleGroup.idle(); // [jscastro] some FBX/GLTF models have too much specular effects for mapbox

                return _context4.abrupt("return", userScaleGroup);

              case 54:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee, this);
      }));

      function loadModel(_x) {
        return _loadModel.apply(this, arguments);
      }

      return loadModel;
    }()
  }]);

  return Threebox;
}();

/* harmony default export */ var src_Threebox = (Threebox_Threebox);
// CONCATENATED MODULE: ./src/ThreeLayer.ts





var ThreeLayer_ThreeLayer = /*#__PURE__*/function () {
  function ThreeLayer(option) {
    classCallCheck_default()(this, ThreeLayer);

    defineProperty_default()(this, "id", void 0);

    defineProperty_default()(this, "type", void 0);

    defineProperty_default()(this, "renderingMode", void 0);

    defineProperty_default()(this, "visible", void 0);

    defineProperty_default()(this, "map", void 0);

    defineProperty_default()(this, "threebox", void 0);

    defineProperty_default()(this, "threeboxOption", void 0);

    this.id = (option === null || option === void 0 ? void 0 : option.id) || 'three-layer';
    this.type = 'custom';
    this.renderingMode = '3d';
    this.visible = (option === null || option === void 0 ? void 0 : option.visible) || true;
    this.threeboxOption = (option === null || option === void 0 ? void 0 : option.threeboxOption) || {};
  } // onRemove?(map: mapboxgl.Map, gl: WebGLRenderingContext): void {
  // 	throw new Error('Method not implemented.');
  // }


  createClass_default()(ThreeLayer, [{
    key: "onAdd",
    value: function onAdd(map, gl) {
      this.map = map;
      this.threebox = new src_Threebox(map, gl, this.threeboxOption);
    } // prerender?(gl: WebGLRenderingContext, matrix: number[]): void {
    // 	throw new Error('Method not implemented.');
    // }

  }, {
    key: "render",
    value: function render(_gl, _matrix) {
      this.threebox.update();
    }
  }]);

  return ThreeLayer;
}();

/* harmony default export */ var src_ThreeLayer = (ThreeLayer_ThreeLayer);
// CONCATENATED MODULE: ./src/handlers/index.ts



// CONCATENATED MODULE: ./src/index.ts




/***/ })

},[[66,0,1]]]);
});